package b4a.example;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new anywheresoftware.b4a.ShellBA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
        WaitForLayout wl = new WaitForLayout();
        if (anywheresoftware.b4a.objects.ServiceHelper.StarterHelper.startFromActivity(processBA, wl, false))
		    BA.handler.postDelayed(wl, 5);

	}
	static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}



public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        b4a.example.dateutils._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}
public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

public static void killProgram() {
     {
            Activity __a = null;
            if (main.previousOne != null) {
				__a = main.previousOne.get();
			}
            else {
                BA ba = main.mostCurrent.processBA.sharedProcessBA.activityBA.get();
                if (ba != null) __a = ba.activity;
            }
            if (__a != null)
				__a.finish();}

BA.applicationContext.stopService(new android.content.Intent(BA.applicationContext, starter.class));
}
public static class _tmayadef_start{
public boolean IsInitialized;
public long datum;
public int KIN;
public int Spiegel;
public int Ton;
public void Initialize() {
IsInitialized = true;
datum = 0L;
KIN = 0;
Spiegel = 0;
Ton = 0;
}
@Override
		public String toString() {
			return BA.TypeToString(this, false);
		}}
public static class _tmayadef_260{
public boolean IsInitialized;
public int Farbe;
public long RGB;
public String Bezeichnung;
public void Initialize() {
IsInitialized = true;
Farbe = 0;
RGB = 0L;
Bezeichnung = "";
}
@Override
		public String toString() {
			return BA.TypeToString(this, false);
		}}
public static class _tmayadef_20{
public boolean IsInitialized;
public String Kraft;
public String Nutzen;
public String Bezeichnung;
public String MayaBez;
public String Eigenschaft;
public String Kurzbez;
public void Initialize() {
IsInitialized = true;
Kraft = "";
Nutzen = "";
Bezeichnung = "";
MayaBez = "";
Eigenschaft = "";
Kurzbez = "";
}
@Override
		public String toString() {
			return BA.TypeToString(this, false);
		}}
public static class _tmayadef_13{
public boolean IsInitialized;
public String Ausrichtung;
public String Eigenschaft;
public String Dimension;
public String Essenz;
public String Aussage;
public String SoIstEs;
public void Initialize() {
IsInitialized = true;
Ausrichtung = "";
Eigenschaft = "";
Dimension = "";
Essenz = "";
Aussage = "";
SoIstEs = "";
}
@Override
		public String toString() {
			return BA.TypeToString(this, false);
		}}
public static class _tmayadef{
public boolean IsInitialized;
public double Transparenz;
public b4a.example.main._tmayadef_start Start;
public b4a.example.main._tmayadef_260[] Kin;
public b4a.example.main._tmayadef_20[] Figur;
public b4a.example.main._tmayadef_13[] Energie;
public void Initialize() {
IsInitialized = true;
Transparenz = 0;
Start = new b4a.example.main._tmayadef_start();
Kin = new b4a.example.main._tmayadef_260[260];
{
int d0 = Kin.length;
for (int i0 = 0;i0 < d0;i0++) {
Kin[i0] = new b4a.example.main._tmayadef_260();
}
}
;
Figur = new b4a.example.main._tmayadef_20[20];
{
int d0 = Figur.length;
for (int i0 = 0;i0 < d0;i0++) {
Figur[i0] = new b4a.example.main._tmayadef_20();
}
}
;
Energie = new b4a.example.main._tmayadef_13[13];
{
int d0 = Energie.length;
for (int i0 = 0;i0 < d0;i0++) {
Energie[i0] = new b4a.example.main._tmayadef_13();
}
}
;
}
@Override
		public String toString() {
			return BA.TypeToString(this, false);
		}}
public static class _tcalenderentry{
public boolean IsInitialized;
public String Wochentag;
public String Datum;
public int valWochentag;
public int AktuellerMond;
public int MonatsKIN;
public int VorMonatsKIN;
public int val_260er;
public int val_20er;
public int val_13er;
public int val_28er;
public void Initialize() {
IsInitialized = true;
Wochentag = "";
Datum = "";
valWochentag = 0;
AktuellerMond = 0;
MonatsKIN = 0;
VorMonatsKIN = 0;
val_260er = 0;
val_20er = 0;
val_13er = 0;
val_28er = 0;
}
@Override
		public String toString() {
			return BA.TypeToString(this, false);
		}}
public static class _tcalender{
public boolean IsInitialized;
public int JahresKIN;
public b4a.example.main._tcalenderentry[] entry;
public void Initialize() {
IsInitialized = true;
JahresKIN = 0;
entry = new b4a.example.main._tcalenderentry[378];
{
int d0 = entry.length;
for (int i0 = 0;i0 < d0;i0++) {
entry[i0] = new b4a.example.main._tcalenderentry();
}
}
;
}
@Override
		public String toString() {
			return BA.TypeToString(this, false);
		}}
public anywheresoftware.b4a.keywords.Common __c = null;
public static byte[] _valmondvorbt = null;
public static String[] _strwochentage = null;
public static int _val_260er = 0;
public static int _val_20er = 0;
public static int _val_13er = 0;
public static int _val_28er = 0;
public static int _valaktuellermond = 0;
public static long _valtagnull = 0L;
public static byte[] _mondayfirst = null;
public static int _nullday = 0;
public static int _nullmonth = 0;
public static int _val_28tagekin = 0;
public static b4a.example.main._tmayadef _mayadef = null;
public static b4a.example.main._tcalender _kalender = null;
public static int _testone = 0;
public anywheresoftware.b4a.objects.ButtonWrapper _btncalcabsolut = null;
public b4a.example.dateutils _dateutils = null;
public b4a.example.starter _starter = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
RDebugUtils.currentModule="main";
uk.co.martinpearman.b4a.xom.XOMBuilder _xombuilder1 = null;
String _xmlstring = "";
RDebugUtils.currentLine=131072;
 //BA.debugLineNum = 131072;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
RDebugUtils.currentLine=131077;
 //BA.debugLineNum = 131077;BA.debugLine="Activity.LoadLayout(\"MayaMain\")";
mostCurrent._activity.LoadLayout("MayaMain",mostCurrent.activityBA);
RDebugUtils.currentLine=131078;
 //BA.debugLineNum = 131078;BA.debugLine="DateTime.DateFormat = \"dd.MM.yyyy\"";
anywheresoftware.b4a.keywords.Common.DateTime.setDateFormat("dd.MM.yyyy");
RDebugUtils.currentLine=131080;
 //BA.debugLineNum = 131080;BA.debugLine="If FirstTime = True Then";
if (_firsttime==anywheresoftware.b4a.keywords.Common.True) { 
RDebugUtils.currentLine=131082;
 //BA.debugLineNum = 131082;BA.debugLine="strWochentage(1) = \"Montag\"";
_strwochentage[(int) (1)] = "Montag";
RDebugUtils.currentLine=131083;
 //BA.debugLineNum = 131083;BA.debugLine="strWochentage(2) = \"Dienstag\"";
_strwochentage[(int) (2)] = "Dienstag";
RDebugUtils.currentLine=131084;
 //BA.debugLineNum = 131084;BA.debugLine="strWochentage(3) = \"Mittwoch\"";
_strwochentage[(int) (3)] = "Mittwoch";
RDebugUtils.currentLine=131085;
 //BA.debugLineNum = 131085;BA.debugLine="strWochentage(4) = \"Donnerstag\"";
_strwochentage[(int) (4)] = "Donnerstag";
RDebugUtils.currentLine=131086;
 //BA.debugLineNum = 131086;BA.debugLine="strWochentage(5) = \"Freitag\"";
_strwochentage[(int) (5)] = "Freitag";
RDebugUtils.currentLine=131087;
 //BA.debugLineNum = 131087;BA.debugLine="strWochentage(6) = \"Samstag\"";
_strwochentage[(int) (6)] = "Samstag";
RDebugUtils.currentLine=131088;
 //BA.debugLineNum = 131088;BA.debugLine="strWochentage(7) = \"Sonntag\"";
_strwochentage[(int) (7)] = "Sonntag";
RDebugUtils.currentLine=131091;
 //BA.debugLineNum = 131091;BA.debugLine="valMondVorBT(0) = 0";
_valmondvorbt[(int) (0)] = (byte) (0);
RDebugUtils.currentLine=131092;
 //BA.debugLineNum = 131092;BA.debugLine="valMondVorBT(1) = 28";
_valmondvorbt[(int) (1)] = (byte) (28);
RDebugUtils.currentLine=131093;
 //BA.debugLineNum = 131093;BA.debugLine="valMondVorBT(2) = 27";
_valmondvorbt[(int) (2)] = (byte) (27);
RDebugUtils.currentLine=131094;
 //BA.debugLineNum = 131094;BA.debugLine="valMondVorBT(3) = 26";
_valmondvorbt[(int) (3)] = (byte) (26);
RDebugUtils.currentLine=131095;
 //BA.debugLineNum = 131095;BA.debugLine="valMondVorBT(4) = 25";
_valmondvorbt[(int) (4)] = (byte) (25);
RDebugUtils.currentLine=131096;
 //BA.debugLineNum = 131096;BA.debugLine="valMondVorBT(5) = 24";
_valmondvorbt[(int) (5)] = (byte) (24);
RDebugUtils.currentLine=131097;
 //BA.debugLineNum = 131097;BA.debugLine="valMondVorBT(6) = 23";
_valmondvorbt[(int) (6)] = (byte) (23);
RDebugUtils.currentLine=131099;
 //BA.debugLineNum = 131099;BA.debugLine="valAktuellerMond = 1";
_valaktuellermond = (int) (1);
RDebugUtils.currentLine=131101;
 //BA.debugLineNum = 131101;BA.debugLine="MondayFirst(1) = 7    'Sonntag";
_mondayfirst[(int) (1)] = (byte) (7);
RDebugUtils.currentLine=131102;
 //BA.debugLineNum = 131102;BA.debugLine="MondayFirst(2) = 1    'Montag";
_mondayfirst[(int) (2)] = (byte) (1);
RDebugUtils.currentLine=131103;
 //BA.debugLineNum = 131103;BA.debugLine="MondayFirst(3) = 2    'Dienstag";
_mondayfirst[(int) (3)] = (byte) (2);
RDebugUtils.currentLine=131104;
 //BA.debugLineNum = 131104;BA.debugLine="MondayFirst(4) = 3    'Mittwoch";
_mondayfirst[(int) (4)] = (byte) (3);
RDebugUtils.currentLine=131105;
 //BA.debugLineNum = 131105;BA.debugLine="MondayFirst(5) = 4    'Donnerstag";
_mondayfirst[(int) (5)] = (byte) (4);
RDebugUtils.currentLine=131106;
 //BA.debugLineNum = 131106;BA.debugLine="MondayFirst(6) = 5    'Freitag";
_mondayfirst[(int) (6)] = (byte) (5);
RDebugUtils.currentLine=131107;
 //BA.debugLineNum = 131107;BA.debugLine="MondayFirst(7) = 6    'Samstag";
_mondayfirst[(int) (7)] = (byte) (6);
 };
RDebugUtils.currentLine=131110;
 //BA.debugLineNum = 131110;BA.debugLine="TestOne = 1";
_testone = (int) (1);
RDebugUtils.currentLine=131111;
 //BA.debugLineNum = 131111;BA.debugLine="Kalender.Initialize";
_kalender.Initialize();
RDebugUtils.currentLine=131112;
 //BA.debugLineNum = 131112;BA.debugLine="MayaDef.Initialize";
_mayadef.Initialize();
RDebugUtils.currentLine=131115;
 //BA.debugLineNum = 131115;BA.debugLine="Dim XOMBuilder1 As XOMBuilder";
_xombuilder1 = new uk.co.martinpearman.b4a.xom.XOMBuilder();
RDebugUtils.currentLine=131116;
 //BA.debugLineNum = 131116;BA.debugLine="XOMBuilder1.Initialize(\"XOMBuilder1\")";
_xombuilder1.Initialize("XOMBuilder1");
RDebugUtils.currentLine=131119;
 //BA.debugLineNum = 131119;BA.debugLine="Dim XmlString As String=File.GetText(File.DirAsse";
_xmlstring = anywheresoftware.b4a.keywords.Common.File.GetText(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"maya.xml");
RDebugUtils.currentLine=131120;
 //BA.debugLineNum = 131120;BA.debugLine="XOMBuilder1.BuildFromString(XmlString, \"\", Null)";
_xombuilder1.BuildFromString(processBA,_xmlstring,"",anywheresoftware.b4a.keywords.Common.Null);
RDebugUtils.currentLine=131122;
 //BA.debugLineNum = 131122;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=262144;
 //BA.debugLineNum = 262144;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
RDebugUtils.currentLine=262146;
 //BA.debugLineNum = 262146;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=196608;
 //BA.debugLineNum = 196608;BA.debugLine="Sub Activity_Resume";
RDebugUtils.currentLine=196610;
 //BA.debugLineNum = 196610;BA.debugLine="End Sub";
return "";
}
public static String  _calcabsolut_click() throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=589824;
 //BA.debugLineNum = 589824;BA.debugLine="Sub CalcAbsolut_Click";
RDebugUtils.currentLine=589827;
 //BA.debugLineNum = 589827;BA.debugLine="CalcKalender(True)";
_calckalender(anywheresoftware.b4a.keywords.Common.True);
RDebugUtils.currentLine=589828;
 //BA.debugLineNum = 589828;BA.debugLine="End Sub";
return "";
}
public static String  _calckalender(boolean _icalabsolut) throws Exception{
RDebugUtils.currentModule="main";
int _zeile = 0;
long _i = 0L;
long _valgeburtstag = 0L;
long _valberechnungsstag = 0L;
long _valstarttagdefinition = 0L;
long _valstarttagkalender = 0L;
long _valactday = 0L;
int _valwochentag = 0;
int _actday = 0;
int _actmonth = 0;
long _dtgeburtstag = 0L;
long _dtactdate = 0L;
String _dtstarttagdefinition = "";
String _dtberechnungstag = "";
String _dtstarttagkalender = "";
String _dtactdatum = "";
long _valwochentagbt = 0L;
long _valdiff_start_bt = 0L;
int _valfarbe = 0;
int _j = 0;
b4a.example.dateutils._period _p = null;
RDebugUtils.currentLine=458752;
 //BA.debugLineNum = 458752;BA.debugLine="Sub CalcKalender(iCalAbsolut As Boolean)";
RDebugUtils.currentLine=458754;
 //BA.debugLineNum = 458754;BA.debugLine="Dim Zeile As Int";
_zeile = 0;
RDebugUtils.currentLine=458755;
 //BA.debugLineNum = 458755;BA.debugLine="Dim i As Long";
_i = 0L;
RDebugUtils.currentLine=458756;
 //BA.debugLineNum = 458756;BA.debugLine="Dim valGeburtstag As Long";
_valgeburtstag = 0L;
RDebugUtils.currentLine=458757;
 //BA.debugLineNum = 458757;BA.debugLine="Dim valBerechnungsstag As Long";
_valberechnungsstag = 0L;
RDebugUtils.currentLine=458758;
 //BA.debugLineNum = 458758;BA.debugLine="Dim valStarttagDefinition As Long";
_valstarttagdefinition = 0L;
RDebugUtils.currentLine=458759;
 //BA.debugLineNum = 458759;BA.debugLine="Dim valStarttagKalender As Long";
_valstarttagkalender = 0L;
RDebugUtils.currentLine=458760;
 //BA.debugLineNum = 458760;BA.debugLine="Dim valActDay As Long";
_valactday = 0L;
RDebugUtils.currentLine=458761;
 //BA.debugLineNum = 458761;BA.debugLine="Dim valWochentag As Int";
_valwochentag = 0;
RDebugUtils.currentLine=458762;
 //BA.debugLineNum = 458762;BA.debugLine="Dim ActDay As Int";
_actday = 0;
RDebugUtils.currentLine=458763;
 //BA.debugLineNum = 458763;BA.debugLine="Dim ActMonth As Int";
_actmonth = 0;
RDebugUtils.currentLine=458765;
 //BA.debugLineNum = 458765;BA.debugLine="Dim dtGeburtstag As Long";
_dtgeburtstag = 0L;
RDebugUtils.currentLine=458766;
 //BA.debugLineNum = 458766;BA.debugLine="Dim dtActDate As Long";
_dtactdate = 0L;
RDebugUtils.currentLine=458768;
 //BA.debugLineNum = 458768;BA.debugLine="Dim dtStarttagDefinition As String";
_dtstarttagdefinition = "";
RDebugUtils.currentLine=458769;
 //BA.debugLineNum = 458769;BA.debugLine="Dim dtBerechnungstag As String";
_dtberechnungstag = "";
RDebugUtils.currentLine=458770;
 //BA.debugLineNum = 458770;BA.debugLine="Dim dtStarttagKalender As String";
_dtstarttagkalender = "";
RDebugUtils.currentLine=458771;
 //BA.debugLineNum = 458771;BA.debugLine="Dim dtActDatum As String";
_dtactdatum = "";
RDebugUtils.currentLine=458774;
 //BA.debugLineNum = 458774;BA.debugLine="Dim valWochentagBT As Long";
_valwochentagbt = 0L;
RDebugUtils.currentLine=458775;
 //BA.debugLineNum = 458775;BA.debugLine="Dim valDiff_Start_BT As Long";
_valdiff_start_bt = 0L;
RDebugUtils.currentLine=458776;
 //BA.debugLineNum = 458776;BA.debugLine="Dim valFarbe As Int";
_valfarbe = 0;
RDebugUtils.currentLine=458778;
 //BA.debugLineNum = 458778;BA.debugLine="Dim j As Int";
_j = 0;
RDebugUtils.currentLine=458780;
 //BA.debugLineNum = 458780;BA.debugLine="ActDay = 0";
_actday = (int) (0);
RDebugUtils.currentLine=458781;
 //BA.debugLineNum = 458781;BA.debugLine="ActMonth = 0";
_actmonth = (int) (0);
RDebugUtils.currentLine=458784;
 //BA.debugLineNum = 458784;BA.debugLine="valStarttagDefinition = MayaDef.Start.datum";
_valstarttagdefinition = _mayadef.Start.datum;
RDebugUtils.currentLine=458785;
 //BA.debugLineNum = 458785;BA.debugLine="valGeburtstag = DateTime.DateParse(\"31.10.1960";
_valgeburtstag = anywheresoftware.b4a.keywords.Common.DateTime.DateParse("31.10.1960");
RDebugUtils.currentLine=458791;
 //BA.debugLineNum = 458791;BA.debugLine="If iCalAbsolut = True Then";
if (_icalabsolut==anywheresoftware.b4a.keywords.Common.True) { 
RDebugUtils.currentLine=458793;
 //BA.debugLineNum = 458793;BA.debugLine="valBerechnungsstag = DateTime.DateParse(\"26";
_valberechnungsstag = anywheresoftware.b4a.keywords.Common.DateTime.DateParse("26.7.2015");
 }else {
RDebugUtils.currentLine=458796;
 //BA.debugLineNum = 458796;BA.debugLine="valBerechnungsstag = valGeburtstag";
_valberechnungsstag = _valgeburtstag;
 };
RDebugUtils.currentLine=458798;
 //BA.debugLineNum = 458798;BA.debugLine="valTagNull = valBerechnungsstag - 1";
_valtagnull = (long) (_valberechnungsstag-1);
RDebugUtils.currentLine=458799;
 //BA.debugLineNum = 458799;BA.debugLine="NullDay = DateTime.GetDayOfMonth(valTagNull)";
_nullday = anywheresoftware.b4a.keywords.Common.DateTime.GetDayOfMonth(_valtagnull);
RDebugUtils.currentLine=458800;
 //BA.debugLineNum = 458800;BA.debugLine="NullMonth = DateTime.GetMonth(valTagNull)";
_nullmonth = anywheresoftware.b4a.keywords.Common.DateTime.GetMonth(_valtagnull);
RDebugUtils.currentLine=458804;
 //BA.debugLineNum = 458804;BA.debugLine="If valBerechnungsstag < valStarttagDefinition";
if (_valberechnungsstag<_valstarttagdefinition) { 
RDebugUtils.currentLine=458805;
 //BA.debugLineNum = 458805;BA.debugLine="Msgbox( \"angegebener Tag ist kleiner als Ta";
anywheresoftware.b4a.keywords.Common.Msgbox("angegebener Tag ist kleiner als Tag der Startdefinition!!","Berechnung nicht möglich!",mostCurrent.activityBA);
 }else {
RDebugUtils.currentLine=458808;
 //BA.debugLineNum = 458808;BA.debugLine="valWochentagBT =  MondayFirst(DateTime.GetDay";
_valwochentagbt = (long) (_mondayfirst[anywheresoftware.b4a.keywords.Common.DateTime.GetDayOfWeek(_valberechnungsstag)]);
RDebugUtils.currentLine=458811;
 //BA.debugLineNum = 458811;BA.debugLine="Dim p As Period";
_p = new b4a.example.dateutils._period();
RDebugUtils.currentLine=458812;
 //BA.debugLineNum = 458812;BA.debugLine="p.Days =  -valWochentagBT + 1";
_p.Days = (int) (-_valwochentagbt+1);
RDebugUtils.currentLine=458814;
 //BA.debugLineNum = 458814;BA.debugLine="valStarttagKalender = DateUtils.AddPeriod(valBer";
_valstarttagkalender = mostCurrent._dateutils._addperiod(mostCurrent.activityBA,_valberechnungsstag,_p);
RDebugUtils.currentLine=458818;
 //BA.debugLineNum = 458818;BA.debugLine="p  = DateUtils.PeriodBetweenInDays(valStartta";
_p = mostCurrent._dateutils._periodbetweenindays(mostCurrent.activityBA,_valstarttagdefinition,_valstarttagkalender);
RDebugUtils.currentLine=458819;
 //BA.debugLineNum = 458819;BA.debugLine="valDiff_Start_BT = p.Days";
_valdiff_start_bt = (long) (_p.Days);
RDebugUtils.currentLine=458822;
 //BA.debugLineNum = 458822;BA.debugLine="dtStarttagDefinition = DateTime.Date(valStart";
_dtstarttagdefinition = anywheresoftware.b4a.keywords.Common.DateTime.Date(_valstarttagdefinition);
RDebugUtils.currentLine=458823;
 //BA.debugLineNum = 458823;BA.debugLine="dtBerechnungstag     = DateTime.Date(valBerec";
_dtberechnungstag = anywheresoftware.b4a.keywords.Common.DateTime.Date(_valberechnungsstag);
RDebugUtils.currentLine=458824;
 //BA.debugLineNum = 458824;BA.debugLine="dtStarttagKalender   = DateTime.Date(valStart";
_dtstarttagkalender = anywheresoftware.b4a.keywords.Common.DateTime.Date(_valstarttagkalender);
RDebugUtils.currentLine=458830;
 //BA.debugLineNum = 458830;BA.debugLine="val_260er = MayaDef.Start.KIN";
_val_260er = _mayadef.Start.KIN;
RDebugUtils.currentLine=458831;
 //BA.debugLineNum = 458831;BA.debugLine="val_20er  = MayaDef.Start.Spiegel";
_val_20er = _mayadef.Start.Spiegel;
RDebugUtils.currentLine=458832;
 //BA.debugLineNum = 458832;BA.debugLine="val_13er  = MayaDef.Start.Ton";
_val_13er = _mayadef.Start.Ton;
RDebugUtils.currentLine=458836;
 //BA.debugLineNum = 458836;BA.debugLine="valActDay = valStarttagDefinition";
_valactday = _valstarttagdefinition;
RDebugUtils.currentLine=458838;
 //BA.debugLineNum = 458838;BA.debugLine="For i = 0 To valDiff_Start_BT - 2";
{
final long step166 = 1;
final long limit166 = (long) (_valdiff_start_bt-2);
for (_i = (long) (0); (step166 > 0 && _i <= limit166) || (step166 < 0 && _i >= limit166); _i = ((long)(0 + _i + step166))) {
RDebugUtils.currentLine=458840;
 //BA.debugLineNum = 458840;BA.debugLine="p.Days =  1";
_p.Days = (int) (1);
RDebugUtils.currentLine=458841;
 //BA.debugLineNum = 458841;BA.debugLine="valActDay = DateUtils.AddPeriod(valActDay,p)";
_valactday = mostCurrent._dateutils._addperiod(mostCurrent.activityBA,_valactday,_p);
RDebugUtils.currentLine=458843;
 //BA.debugLineNum = 458843;BA.debugLine="CalcNextDay (valActDay)";
_calcnextday(_valactday);
 }
};
RDebugUtils.currentLine=458847;
 //BA.debugLineNum = 458847;BA.debugLine="val_28er = valMondVorBT(valWochentagBT - 1)";
_val_28er = (int) (_valmondvorbt[(int) (_valwochentagbt-1)]);
RDebugUtils.currentLine=458849;
 //BA.debugLineNum = 458849;BA.debugLine="dtActDatum = DateTime.Date(valActDay)";
_dtactdatum = anywheresoftware.b4a.keywords.Common.DateTime.Date(_valactday);
RDebugUtils.currentLine=458851;
 //BA.debugLineNum = 458851;BA.debugLine="For i = 0 To 377";
{
final long step173 = 1;
final long limit173 = (long) (377);
for (_i = (long) (0); (step173 > 0 && _i <= limit173) || (step173 < 0 && _i >= limit173); _i = ((long)(0 + _i + step173))) {
RDebugUtils.currentLine=458852;
 //BA.debugLineNum = 458852;BA.debugLine="p.Days =  1";
_p.Days = (int) (1);
RDebugUtils.currentLine=458853;
 //BA.debugLineNum = 458853;BA.debugLine="valActDay = DateUtils.AddPeriod(valActDay,p)";
_valactday = mostCurrent._dateutils._addperiod(mostCurrent.activityBA,_valactday,_p);
RDebugUtils.currentLine=458855;
 //BA.debugLineNum = 458855;BA.debugLine="CalcNextDay (valActDay)";
_calcnextday(_valactday);
RDebugUtils.currentLine=458856;
 //BA.debugLineNum = 458856;BA.debugLine="valWochentag = MondayFirst(DateTime.GetDa";
_valwochentag = (int) (_mondayfirst[anywheresoftware.b4a.keywords.Common.DateTime.GetDayOfWeek(_valactday)]);
RDebugUtils.currentLine=458858;
 //BA.debugLineNum = 458858;BA.debugLine="Kalender.Entry(i).Wochentag    = strWoche";
_kalender.entry[(int) (_i)].Wochentag = _strwochentage[_valwochentag];
RDebugUtils.currentLine=458859;
 //BA.debugLineNum = 458859;BA.debugLine="Kalender.Entry(i).Datum        = DateTime";
_kalender.entry[(int) (_i)].Datum = anywheresoftware.b4a.keywords.Common.DateTime.Date(_valactday);
RDebugUtils.currentLine=458860;
 //BA.debugLineNum = 458860;BA.debugLine="Kalender.Entry(i).valWochentag = valWoche";
_kalender.entry[(int) (_i)].valWochentag = _valwochentag;
RDebugUtils.currentLine=458862;
 //BA.debugLineNum = 458862;BA.debugLine="Kalender.Entry(i).val_260er = val_260er";
_kalender.entry[(int) (_i)].val_260er = _val_260er;
RDebugUtils.currentLine=458863;
 //BA.debugLineNum = 458863;BA.debugLine="Kalender.Entry(i).val_20er  = val_20er";
_kalender.entry[(int) (_i)].val_20er = _val_20er;
RDebugUtils.currentLine=458864;
 //BA.debugLineNum = 458864;BA.debugLine="Kalender.Entry(i).val_13er  = val_13er";
_kalender.entry[(int) (_i)].val_13er = _val_13er;
RDebugUtils.currentLine=458865;
 //BA.debugLineNum = 458865;BA.debugLine="Kalender.Entry(i).val_28er  = val_28er";
_kalender.entry[(int) (_i)].val_28er = _val_28er;
RDebugUtils.currentLine=458869;
 //BA.debugLineNum = 458869;BA.debugLine="If val_28er = 1 Then";
if (_val_28er==1) { 
RDebugUtils.currentLine=458870;
 //BA.debugLineNum = 458870;BA.debugLine="Zeile = i - (valWochentag - 1)";
_zeile = (int) (_i-(_valwochentag-1));
RDebugUtils.currentLine=458871;
 //BA.debugLineNum = 458871;BA.debugLine="If Zeile <> 0 Then";
if (_zeile!=0) { 
RDebugUtils.currentLine=458872;
 //BA.debugLineNum = 458872;BA.debugLine="If valAktuellerMond < 13 Then";
if (_valaktuellermond<13) { 
RDebugUtils.currentLine=458873;
 //BA.debugLineNum = 458873;BA.debugLine="valAktuellerMond = valAktuellerM";
_valaktuellermond = (int) (_valaktuellermond+1);
 }else {
RDebugUtils.currentLine=458875;
 //BA.debugLineNum = 458875;BA.debugLine="valAktuellerMond = 1";
_valaktuellermond = (int) (1);
 };
 };
RDebugUtils.currentLine=458878;
 //BA.debugLineNum = 458878;BA.debugLine="Kalender.Entry(Zeile).AktuellerMond";
_kalender.entry[_zeile].AktuellerMond = _valaktuellermond;
RDebugUtils.currentLine=458880;
 //BA.debugLineNum = 458880;BA.debugLine="If val_28TageKIN <> 0 Then";
if (_val_28tagekin!=0) { 
RDebugUtils.currentLine=458881;
 //BA.debugLineNum = 458881;BA.debugLine="Kalender.Entry(Zeile).VorMonatsK";
_kalender.entry[_zeile].VorMonatsKIN = _val_28tagekin;
 }else {
RDebugUtils.currentLine=458883;
 //BA.debugLineNum = 458883;BA.debugLine="Kalender.Entry(Zeile).VorMonatsK";
_kalender.entry[_zeile].VorMonatsKIN = (int) (0);
 };
RDebugUtils.currentLine=458885;
 //BA.debugLineNum = 458885;BA.debugLine="val_28TageKIN = val_260er  * TestOne";
_val_28tagekin = (int) (_val_260er*_testone);
RDebugUtils.currentLine=458886;
 //BA.debugLineNum = 458886;BA.debugLine="Kalender.Entry(Zeile).MonatsKIN  =";
_kalender.entry[_zeile].MonatsKIN = _val_28tagekin;
 };
RDebugUtils.currentLine=458890;
 //BA.debugLineNum = 458890;BA.debugLine="ActDay = DateTime.GetDayOfMonth(valActDay";
_actday = anywheresoftware.b4a.keywords.Common.DateTime.GetDayOfMonth(_valactday);
RDebugUtils.currentLine=458891;
 //BA.debugLineNum = 458891;BA.debugLine="ActMonth = DateTime.GetMonth(valActDay)";
_actmonth = anywheresoftware.b4a.keywords.Common.DateTime.GetMonth(_valactday);
RDebugUtils.currentLine=458892;
 //BA.debugLineNum = 458892;BA.debugLine="If DateTime.Date(valBerechnungsstag) = Da";
if ((anywheresoftware.b4a.keywords.Common.DateTime.Date(_valberechnungsstag)).equals(anywheresoftware.b4a.keywords.Common.DateTime.Date(_valactday))) { 
RDebugUtils.currentLine=458893;
 //BA.debugLineNum = 458893;BA.debugLine="Kalender.JahresKIN = val_260er";
_kalender.JahresKIN = _val_260er;
 };
RDebugUtils.currentLine=458899;
 //BA.debugLineNum = 458899;BA.debugLine="If valWochentag = 1 Then";
if (_valwochentag==1) { 
RDebugUtils.currentLine=458903;
 //BA.debugLineNum = 458903;BA.debugLine="Kalender.Entry(i).AktuellerMond  =";
_kalender.entry[(int) (_i)].AktuellerMond = _valaktuellermond;
RDebugUtils.currentLine=458905;
 //BA.debugLineNum = 458905;BA.debugLine="Kalender.Entry(i).MonatsKIN  = val_";
_kalender.entry[(int) (_i)].MonatsKIN = _val_28tagekin;
 };
 }
};
 };
RDebugUtils.currentLine=458911;
 //BA.debugLineNum = 458911;BA.debugLine="End Sub";
return "";
}
public static String  _calcnextday(long _actdate) throws Exception{
RDebugUtils.currentModule="main";
int _lactday = 0;
int _lactmonth = 0;
int _loc_260er = 0;
int _loc_20er = 0;
int _loc_13er = 0;
int _loc_28er = 0;
RDebugUtils.currentLine=524288;
 //BA.debugLineNum = 524288;BA.debugLine="Sub CalcNextDay(ActDate As Long)";
RDebugUtils.currentLine=524290;
 //BA.debugLineNum = 524290;BA.debugLine="Dim lActDay As Int";
_lactday = 0;
RDebugUtils.currentLine=524291;
 //BA.debugLineNum = 524291;BA.debugLine="Dim lActMonth As Int";
_lactmonth = 0;
RDebugUtils.currentLine=524292;
 //BA.debugLineNum = 524292;BA.debugLine="Dim loc_260er, loc_20er, loc_13er, loc_28er As";
_loc_260er = 0;
_loc_20er = 0;
_loc_13er = 0;
_loc_28er = 0;
RDebugUtils.currentLine=524295;
 //BA.debugLineNum = 524295;BA.debugLine="lActDay = DateTime.GetDayOfMonth(ActDate)";
_lactday = anywheresoftware.b4a.keywords.Common.DateTime.GetDayOfMonth(_actdate);
RDebugUtils.currentLine=524296;
 //BA.debugLineNum = 524296;BA.debugLine="lActMonth = DateTime.GetMonth(ActDate)";
_lactmonth = anywheresoftware.b4a.keywords.Common.DateTime.GetMonth(_actdate);
RDebugUtils.currentLine=524299;
 //BA.debugLineNum = 524299;BA.debugLine="If (lActDay <> 29) Or (lActMonth <> 2) Then";
if ((_lactday!=29) || (_lactmonth!=2)) { 
RDebugUtils.currentLine=524301;
 //BA.debugLineNum = 524301;BA.debugLine="loc_260er = val_260er - 1";
_loc_260er = (int) (_val_260er-1);
RDebugUtils.currentLine=524302;
 //BA.debugLineNum = 524302;BA.debugLine="loc_20er = val_20er - 1";
_loc_20er = (int) (_val_20er-1);
RDebugUtils.currentLine=524303;
 //BA.debugLineNum = 524303;BA.debugLine="loc_13er = val_13er - 1";
_loc_13er = (int) (_val_13er-1);
RDebugUtils.currentLine=524304;
 //BA.debugLineNum = 524304;BA.debugLine="loc_28er = val_28er - 1";
_loc_28er = (int) (_val_28er-1);
RDebugUtils.currentLine=524306;
 //BA.debugLineNum = 524306;BA.debugLine="loc_260er = (loc_260er + 1) Mod 260     'K";
_loc_260er = (int) ((_loc_260er+1)%260);
RDebugUtils.currentLine=524307;
 //BA.debugLineNum = 524307;BA.debugLine="loc_20er = (loc_20er + 1) Mod 20        '";
_loc_20er = (int) ((_loc_20er+1)%20);
RDebugUtils.currentLine=524308;
 //BA.debugLineNum = 524308;BA.debugLine="loc_13er = (loc_13er + 1) Mod 13        'T";
_loc_13er = (int) ((_loc_13er+1)%13);
RDebugUtils.currentLine=524309;
 //BA.debugLineNum = 524309;BA.debugLine="loc_28er = (loc_28er + 1) Mod 28        'M";
_loc_28er = (int) ((_loc_28er+1)%28);
RDebugUtils.currentLine=524311;
 //BA.debugLineNum = 524311;BA.debugLine="val_260er = loc_260er + 1";
_val_260er = (int) (_loc_260er+1);
RDebugUtils.currentLine=524312;
 //BA.debugLineNum = 524312;BA.debugLine="val_20er = loc_20er + 1";
_val_20er = (int) (_loc_20er+1);
RDebugUtils.currentLine=524313;
 //BA.debugLineNum = 524313;BA.debugLine="val_13er = loc_13er + 1";
_val_13er = (int) (_loc_13er+1);
RDebugUtils.currentLine=524318;
 //BA.debugLineNum = 524318;BA.debugLine="If (lActDay <> NullDay) Or (lActMonth <> N";
if ((_lactday!=_nullday) || (_lactmonth!=_nullmonth)) { 
RDebugUtils.currentLine=524319;
 //BA.debugLineNum = 524319;BA.debugLine="val_28er = loc_28er + 1";
_val_28er = (int) (_loc_28er+1);
 }else {
RDebugUtils.currentLine=524321;
 //BA.debugLineNum = 524321;BA.debugLine="val_28er = 0";
_val_28er = (int) (0);
 };
 };
RDebugUtils.currentLine=524324;
 //BA.debugLineNum = 524324;BA.debugLine="End Sub";
return "";
}
public static String  _listview1_itemclick(int _position,Object _value) throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=327680;
 //BA.debugLineNum = 327680;BA.debugLine="Sub ListView1_ItemClick (Position As Int, Value As";
RDebugUtils.currentLine=327681;
 //BA.debugLineNum = 327681;BA.debugLine="Activity.Title = Value";
mostCurrent._activity.setTitle(_value);
RDebugUtils.currentLine=327682;
 //BA.debugLineNum = 327682;BA.debugLine="End Sub";
return "";
}
public static String  _xombuilder1_builddone(uk.co.martinpearman.b4a.xom.XOMDocument _xomdocument1,Object _tag) throws Exception{
RDebugUtils.currentModule="main";
uk.co.martinpearman.b4a.xom.XOMElement _rootelement = null;
uk.co.martinpearman.b4a.xom.XOMElement _firstchild = null;
uk.co.martinpearman.b4a.xom.XOMElements _children = null;
int _i = 0;
int _elementscount = 0;
RDebugUtils.currentLine=393216;
 //BA.debugLineNum = 393216;BA.debugLine="Sub XOMBuilder1_BuildDone(XOMDocument1 As XOMDocum";
RDebugUtils.currentLine=393217;
 //BA.debugLineNum = 393217;BA.debugLine="If XOMDocument1.IsInitialized Then";
if (_xomdocument1.IsInitialized()) { 
RDebugUtils.currentLine=393218;
 //BA.debugLineNum = 393218;BA.debugLine="Log(\"XOMDocument is initialized\")";
anywheresoftware.b4a.keywords.Common.Log("XOMDocument is initialized");
RDebugUtils.currentLine=393219;
 //BA.debugLineNum = 393219;BA.debugLine="Dim RootElement As XOMElement";
_rootelement = new uk.co.martinpearman.b4a.xom.XOMElement();
RDebugUtils.currentLine=393220;
 //BA.debugLineNum = 393220;BA.debugLine="Dim FirstChild As XOMElement";
_firstchild = new uk.co.martinpearman.b4a.xom.XOMElement();
RDebugUtils.currentLine=393221;
 //BA.debugLineNum = 393221;BA.debugLine="Dim Children As XOMElements";
_children = new uk.co.martinpearman.b4a.xom.XOMElements();
RDebugUtils.currentLine=393222;
 //BA.debugLineNum = 393222;BA.debugLine="Dim i, ElementsCount As Int";
_i = 0;
_elementscount = 0;
RDebugUtils.currentLine=393224;
 //BA.debugLineNum = 393224;BA.debugLine="RootElement=XOMDocument1.RootElement";
_rootelement = _xomdocument1.getRootElement();
RDebugUtils.currentLine=393227;
 //BA.debugLineNum = 393227;BA.debugLine="FirstChild = RootElement.GetFirstChildElement";
_firstchild = _rootelement.GetFirstChildElementByName("startvalues");
RDebugUtils.currentLine=393228;
 //BA.debugLineNum = 393228;BA.debugLine="MayaDef.Start.Datum   = DateTime.DateParse(Fi";
_mayadef.Start.datum = anywheresoftware.b4a.keywords.Common.DateTime.DateParse(_firstchild.GetFirstChildElementByName("datum").getValue());
RDebugUtils.currentLine=393229;
 //BA.debugLineNum = 393229;BA.debugLine="MayaDef.Start.KIN     = FirstChild.GetFirstCh";
_mayadef.Start.KIN = (int)(Double.parseDouble(_firstchild.GetFirstChildElementByName("KIN").getValue()));
RDebugUtils.currentLine=393230;
 //BA.debugLineNum = 393230;BA.debugLine="MayaDef.Start.Spiegel = FirstChild.GetFirstCh";
_mayadef.Start.Spiegel = (int)(Double.parseDouble(_firstchild.GetFirstChildElementByName("Spiegel").getValue()));
RDebugUtils.currentLine=393231;
 //BA.debugLineNum = 393231;BA.debugLine="MayaDef.Start.Ton     = FirstChild.GetFirstCh";
_mayadef.Start.Ton = (int)(Double.parseDouble(_firstchild.GetFirstChildElementByName("Ton").getValue()));
RDebugUtils.currentLine=393236;
 //BA.debugLineNum = 393236;BA.debugLine="FirstChild = RootElement.GetFirstChildElement";
_firstchild = _rootelement.GetFirstChildElementByName("kins");
RDebugUtils.currentLine=393237;
 //BA.debugLineNum = 393237;BA.debugLine="Children = FirstChild.GetChildElementsByName(";
_children = _firstchild.GetChildElementsByName("kin");
RDebugUtils.currentLine=393238;
 //BA.debugLineNum = 393238;BA.debugLine="ElementsCount = Children.Size";
_elementscount = _children.Size();
RDebugUtils.currentLine=393239;
 //BA.debugLineNum = 393239;BA.debugLine="For i=0 To ElementsCount-1";
{
final int step85 = 1;
final int limit85 = (int) (_elementscount-1);
for (_i = (int) (0); (step85 > 0 && _i <= limit85) || (step85 < 0 && _i >= limit85); _i = ((int)(0 + _i + step85))) {
RDebugUtils.currentLine=393240;
 //BA.debugLineNum = 393240;BA.debugLine="MayaDef.Kin(i).bezeichnung = Children.GetEl";
_mayadef.Kin[_i].Bezeichnung = _children.GetElement(_i).GetFirstChildElementByName("bezeichnung").getValue();
RDebugUtils.currentLine=393241;
 //BA.debugLineNum = 393241;BA.debugLine="MayaDef.Kin(i).Farbe = Children.GetElement(";
_mayadef.Kin[_i].Farbe = (int)(Double.parseDouble(_children.GetElement(_i).GetFirstChildElementByName("farbe").getValue()));
RDebugUtils.currentLine=393242;
 //BA.debugLineNum = 393242;BA.debugLine="MayaDef.Kin(i).RGB = Children.GetElement(i)";
_mayadef.Kin[_i].RGB = (long)(Double.parseDouble(_children.GetElement(_i).GetFirstChildElementByName("rgb").getValue()));
 }
};
RDebugUtils.currentLine=393247;
 //BA.debugLineNum = 393247;BA.debugLine="FirstChild = RootElement.GetFirstChildElement";
_firstchild = _rootelement.GetFirstChildElementByName("def13");
RDebugUtils.currentLine=393248;
 //BA.debugLineNum = 393248;BA.debugLine="Children = FirstChild.GetChildElementsByName(";
_children = _firstchild.GetChildElementsByName("def");
RDebugUtils.currentLine=393249;
 //BA.debugLineNum = 393249;BA.debugLine="ElementsCount = Children.Size";
_elementscount = _children.Size();
RDebugUtils.currentLine=393250;
 //BA.debugLineNum = 393250;BA.debugLine="For i=0 To ElementsCount-1";
{
final int step93 = 1;
final int limit93 = (int) (_elementscount-1);
for (_i = (int) (0); (step93 > 0 && _i <= limit93) || (step93 < 0 && _i >= limit93); _i = ((int)(0 + _i + step93))) {
RDebugUtils.currentLine=393251;
 //BA.debugLineNum = 393251;BA.debugLine="MayaDef.Energie(i).Ausrichtung = Children.G";
_mayadef.Energie[_i].Ausrichtung = _children.GetElement(_i).GetFirstChildElementByName("ausrichtung").getValue();
RDebugUtils.currentLine=393252;
 //BA.debugLineNum = 393252;BA.debugLine="MayaDef.Energie(i).Eigenschaft = Children.G";
_mayadef.Energie[_i].Eigenschaft = _children.GetElement(_i).GetFirstChildElementByName("eigenschaft").getValue();
RDebugUtils.currentLine=393253;
 //BA.debugLineNum = 393253;BA.debugLine="MayaDef.Energie(i).Dimension = Children.Get";
_mayadef.Energie[_i].Dimension = _children.GetElement(_i).GetFirstChildElementByName("dimension").getValue();
RDebugUtils.currentLine=393254;
 //BA.debugLineNum = 393254;BA.debugLine="MayaDef.Energie(i).Essenz = Children.GetEle";
_mayadef.Energie[_i].Essenz = _children.GetElement(_i).GetFirstChildElementByName("essenz").getValue();
RDebugUtils.currentLine=393255;
 //BA.debugLineNum = 393255;BA.debugLine="MayaDef.Energie(i).Aussage = Children.GetEl";
_mayadef.Energie[_i].Aussage = _children.GetElement(_i).GetFirstChildElementByName("aussage").getValue();
RDebugUtils.currentLine=393256;
 //BA.debugLineNum = 393256;BA.debugLine="MayaDef.Energie(i).SoIstEs = Children.GetEl";
_mayadef.Energie[_i].SoIstEs = _children.GetElement(_i).GetFirstChildElementByName("soistes").getValue();
 }
};
RDebugUtils.currentLine=393260;
 //BA.debugLineNum = 393260;BA.debugLine="FirstChild = RootElement.GetFirstChildElement";
_firstchild = _rootelement.GetFirstChildElementByName("def20");
RDebugUtils.currentLine=393261;
 //BA.debugLineNum = 393261;BA.debugLine="Children = FirstChild.GetChildElementsByName(";
_children = _firstchild.GetChildElementsByName("def");
RDebugUtils.currentLine=393262;
 //BA.debugLineNum = 393262;BA.debugLine="ElementsCount = Children.Size";
_elementscount = _children.Size();
RDebugUtils.currentLine=393263;
 //BA.debugLineNum = 393263;BA.debugLine="For i=0 To ElementsCount-1";
{
final int step104 = 1;
final int limit104 = (int) (_elementscount-1);
for (_i = (int) (0); (step104 > 0 && _i <= limit104) || (step104 < 0 && _i >= limit104); _i = ((int)(0 + _i + step104))) {
RDebugUtils.currentLine=393264;
 //BA.debugLineNum = 393264;BA.debugLine="MayaDef.Figur(i).Kraft = Children.GetElemen";
_mayadef.Figur[_i].Kraft = _children.GetElement(_i).GetFirstChildElementByName("kraft").getValue();
RDebugUtils.currentLine=393265;
 //BA.debugLineNum = 393265;BA.debugLine="MayaDef.Figur(i).Nutzen = Children.GetEleme";
_mayadef.Figur[_i].Nutzen = _children.GetElement(_i).GetFirstChildElementByName("nutzen").getValue();
RDebugUtils.currentLine=393266;
 //BA.debugLineNum = 393266;BA.debugLine="MayaDef.Figur(i).Bezeichnung = Children.Get";
_mayadef.Figur[_i].Bezeichnung = _children.GetElement(_i).GetFirstChildElementByName("bezeichnung").getValue();
RDebugUtils.currentLine=393267;
 //BA.debugLineNum = 393267;BA.debugLine="MayaDef.Figur(i).MayaBez = Children.GetElem";
_mayadef.Figur[_i].MayaBez = _children.GetElement(_i).GetFirstChildElementByName("mayabez").getValue();
RDebugUtils.currentLine=393268;
 //BA.debugLineNum = 393268;BA.debugLine="MayaDef.Figur(i).Eigenschaft = Children.Get";
_mayadef.Figur[_i].Eigenschaft = _children.GetElement(_i).GetFirstChildElementByName("eigenschaft").getValue();
RDebugUtils.currentLine=393269;
 //BA.debugLineNum = 393269;BA.debugLine="MayaDef.Figur(i).Kurzbez = Children.GetElem";
_mayadef.Figur[_i].Kurzbez = _children.GetElement(_i).GetFirstChildElementByName("kurzbez").getValue();
 }
};
 }else {
RDebugUtils.currentLine=393274;
 //BA.debugLineNum = 393274;BA.debugLine="Log(\"An error has occured and the XOMDocument";
anywheresoftware.b4a.keywords.Common.Log("An error has occured and the XOMDocument has NOT been initialized");
RDebugUtils.currentLine=393275;
 //BA.debugLineNum = 393275;BA.debugLine="Log(LastException.Message)";
anywheresoftware.b4a.keywords.Common.Log(anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA).getMessage());
 };
RDebugUtils.currentLine=393277;
 //BA.debugLineNum = 393277;BA.debugLine="End Sub";
return "";
}
}